Index: /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/Writer.pl
===================================================================
--- /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/Writer.pl	(revision 34920)
+++ /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/Writer.pl	(revision 34921)
@@ -4280,24 +5568,32 @@
                     Parent  => 'APP1',
                 );
+                $$path[$pn] = 'APP1';
                 my $buff = $self->WriteDirectory(\%dirInfo, $tagTablePtr, \&WriteTIFF);
                 if (defined $buff and length $buff) {
-                    my $size = length($buff) + length($exifAPP1hdr);
-                    if ($size <= $maxSegmentLen) {
-                        # switch to buffered output if required
-                        if (($$self{PREVIEW_INFO} or $$self{LeicaTrailer}) and not $oldOutfile) {
-                            $writeBuffer = '';
-                            $oldOutfile = $outfile;
-                            $outfile = \$writeBuffer;
-                            # account for segment, EXIF and TIFF headers
-                            $$self{PREVIEW_INFO}{Fixup}{Start} += 18 if $$self{PREVIEW_INFO};
-                            $$self{LeicaTrailer}{Fixup}{Start} += 18 if $$self{LeicaTrailer};
+                    if (length($buff) + length($exifAPP1hdr) > $maxSegmentLen) {
+                        if ($self->Options('NoMultiExif')) {
+                            $self->Error('EXIF is too large for JPEG segment');
+                        } else {
+                            $self->Warn('Creating multi-segment EXIF',1);
                         }
-                        # write the new segment with appropriate header
-                        my $app1hdr = "\xff\xe1" . pack('n', $size + 2);
-                        Write($outfile,$app1hdr,$exifAPP1hdr,$buff) or $err = 1;
-                    } else {
-                        delete $self->{PREVIEW_INFO};
-                        $self->Warn("EXIF APP1 segment too large! ($size bytes)");
-                    }
+                    }
+                    # switch to buffered output if required
+                    if (($$self{PREVIEW_INFO} or $$self{LeicaTrailer}) and not $oldOutfile) {
+                        $writeBuffer = '';
+                        $oldOutfile = $outfile;
+                        $outfile = \$writeBuffer;
+                        # account for segment, EXIF and TIFF headers
+                        $$self{PREVIEW_INFO}{Fixup}{Start} += 18 if $$self{PREVIEW_INFO};
+                        $$self{LeicaTrailer}{Fixup}{Start} += 18 if $$self{LeicaTrailer};
+                    }
+                    # write as multi-segment
+                    my $n = WriteMultiSegment($outfile, 0xe1, $exifAPP1hdr, \$buff, 'EXIF');
+                    if (not $n) {
+                        $err = 1;
+                    } elsif ($n > 1 and $oldOutfile) {
+                        # (punt on this because updating the pointers would be a real pain)
+                        $self->Error("Can't write multi-segment EXIF with external pointers");
+                    }
+                    ++$$self{CHANGED};
                 }
             }
@@ -4312,8 +5608,9 @@
                     Parent => 'APP13',
                 );
+                $$path[$pn] = 'APP13';
                 my $buff = $self->WriteDirectory(\%dirInfo, $tagTablePtr);
                 if (defined $buff and length $buff) {
                     WriteMultiSegment($outfile, 0xed, $psAPP13hdr, \$buff) or $err = 1;
-                    ++$self->{CHANGED};
+                    ++$$self{CHANGED};
                 }
             }
@@ -4330,4 +5627,5 @@
                     MaxDataLen  => $maxXMPLen - length($xmpAPP1hdr),
                 );
+                $$path[$pn] = 'APP1';
                 my $buff = $self->WriteDirectory(\%dirInfo, $tagTablePtr);
                 if (defined $buff and length $buff) {
@@ -4347,8 +5645,9 @@
                     Parent   => 'APP2',
                 );
+                $$path[$pn] = 'APP2';
                 my $buff = $self->WriteDirectory(\%dirInfo, $tagTablePtr);
                 if (defined $buff and length $buff) {
                     WriteMultiSegment($outfile, 0xe2, "ICC_PROFILE\0", \$buff, 'ICC') or $err = 1;
-                    ++$self->{CHANGED};
+                    ++$$self{CHANGED};
                 }
             }
@@ -4363,4 +5662,5 @@
                     Parent   => 'APP12',
                 );
+                $$path[$pn] = 'APP12';
                 my $buff = $self->WriteDirectory(\%dirInfo, $tagTablePtr);
                 if (defined $buff and length $buff) {
@@ -4371,5 +5671,23 @@
                         Write($outfile, $app12hdr, 'Ducky', $buff) or $err = 1;
                     } else {
-                        $self->Warn("Ducky APP12 segment too large! ($size bytes)");
+                        $self->Warn("APP12 Ducky segment too large! ($size bytes)");
+                    }
+                }
+            }
+            # then APP14 Adobe segment
+            last if $dirCount{Adobe};
+            if (exists $$addDirs{Adobe} and not defined $doneDir{Adobe}) {
+                $doneDir{Adobe} = 1;
+                my $buff = $self->GetNewValue('Adobe');
+                if ($buff) {
+                    $verbose and print $out "Creating APP14:\n  Creating Adobe segment\n";
+                    my $size = length($buff);
+                    if ($size <= $maxSegmentLen) {
+                        # write the new segment with appropriate header
+                        my $app14hdr = "\xff\xee" . pack('n', $size + 2);
+                        Write($outfile, $app14hdr, $buff) or $err = 1;
+                        ++$$self{CHANGED};
+                    } else {
+                        $self->Warn("APP14 Adobe segment too large! ($size bytes)");
                     }
                 }
@@ -4380,6 +5698,6 @@
                 $doneDir{COM} = 1;
                 next if $$delGroup{File} and $$delGroup{File} != 2;
-                my $newComment = $self->GetNewValues('Comment');
-                if (defined $newComment and length($newComment)) {
+                my $newComment = $self->GetNewValue('Comment');
+                if (defined $newComment) {
                     if ($verbose) {
                         print $out "Creating COM:\n";
@@ -4387,9 +5705,10 @@
                     }
                     WriteMultiSegment($outfile, 0xfe, '', \$newComment) or $err = 1;
-                    ++$self->{CHANGED};
+                    ++$$self{CHANGED};
                 }
             }
             last;   # didn't want to loop anyway
         }
+        $$path[$pn] = $markerName;
         # decrement counter for this directory since we are about to process it
         --$dirCount{$dirName};
@@ -4409,7 +5728,8 @@
             Write($outfile, $hdr, $s, $segData) or $err = 1;
             my ($buff, $endPos, $trailInfo);
-            my $delPreview = $self->{DEL_PREVIEW};
+            my $delPreview = $$self{DEL_PREVIEW};
             $trailInfo = IdentifyTrailer($raf) unless $$delGroup{Trailer};
-            unless ($oldOutfile or $delPreview or $trailInfo or $$delGroup{Trailer}) {
+            my $nvTrail = $self->GetNewValueHash($Image::ExifTool::Extra{Trailer});
+            unless ($oldOutfile or $delPreview or $trailInfo or $$delGroup{Trailer} or $nvTrail) {
                 # blindly copy the rest of the file
                 while ($raf->Read($buff, 65536)) {
@@ -4442,5 +5762,18 @@
             # remember position of last data copied
             $endPos = $raf->Tell() - length($buff);
-            # rewrite trailers if they exist
+            # write new trailer if specified
+            if ($nvTrail) {
+                # access new value directly to avoid copying a potentially very large data block
+                if ($$nvTrail{Value} and $$nvTrail{Value}[0]) { # (note: "0" will also delete the trailer)
+                    $self->VPrint(0, '  Writing new trailer');
+                    Write($outfile, $$nvTrail{Value}[0]) or $err = 1;
+                    ++$$self{CHANGED};
+                } elsif ($raf->Seek(0, 2) and $raf->Tell() != $endPos) {
+                    $self->VPrint(0, '  Deleting trailer (', $raf->Tell() - $endPos, ' bytes)');
+                    ++$$self{CHANGED};  # changed if there was previously a trailer
+                }
+                last;   # all done
+            }
+            # rewrite existing trailers
             if ($trailInfo) {
                 my $tbuf = '';
@@ -4473,7 +5806,7 @@
                 # use this fixup to set the size too (sneaky)
                 my $trailSize = defined($dat) ? length($dat) - $junk : $$self{LeicaTrailer}{Size};
-                $fixup->{Start} -= 4;  $fixup->{Shift} += 4;
-                $fixup->SetMarkerPointers($outfile, 'LeicaTrailer', $trailSize);
-                $fixup->{Start} += 4;  $fixup->{Shift} -= 4;
+                $$fixup{Start} -= 4;  $$fixup{Shift} += 4;
+                $fixup->SetMarkerPointers($outfile, 'LeicaTrailer', $trailSize) if defined $trailSize;
+                $$fixup{Start} += 4;  $$fixup{Shift} -= 4;
                 # clean up and write the buffered data
                 $outfile = $oldOutfile;
@@ -4487,5 +5820,5 @@
             } else {
                 # locate preview image and fix up preview offsets
-                my $scanLen = $$self{Make} =~ /Sony/i ? 65536 : 1024;
+                my $scanLen = $$self{Make} =~ /^SONY/i ? 65536 : 1024;
                 if (length($buff) < $scanLen) { # make sure we have enough trailer to scan
                     my $buf2;
@@ -4495,14 +5828,31 @@
                 my $newPos = length($$outfile) - 10; # (subtract 10 for segment and EXIF headers)
                 my $junkLen;
-                # adjust position if image isn't at the start (ie. Olympus E-1/E-300)
-                if ($buff =~ m/(\xff\xd8\xff.|.\xd8\xff\xdb)/sg) {
-                    $junkLen = pos($buff) - 4;
+                # adjust position if image isn't at the start (eg. Olympus E-1/E-300)
+                if ($buff =~ /(\xff\xd8\xff.|.\xd8\xff\xdb)(..)/sg) {
+                    my ($jpegHdr, $segLen) = ($1, $2);
+                    $junkLen = pos($buff) - 6;
                     # Sony previewimage trailer has a 32 byte header
-                    $junkLen -= 32 if $$self{Make} =~/SONY/i and $junkLen > 32;
+                    if ($$self{Make} =~ /^SONY/i and $junkLen > 32) {
+                        # with some newer Sony models, the makernotes preview pointer
+                        # points to JPEG at end of EXIF inside MPImage preview (what a pain!)
+                        if ($jpegHdr eq "\xff\xd8\xff\xe1") {   # is the first segment EXIF?
+                            $segLen = unpack('n', $segLen);     # the EXIF segment length
+                            # Sony PreviewImage starts with last 2 bytes of EXIF segment
+                            # (and first byte is usually "\0", not "\xff", so don't check this)
+                            if (length($buff) > $junkLen + $segLen + 6 and
+                                substr($buff, $junkLen + $segLen + 3, 3) eq "\xd8\xff\xdb")
+                            {
+                                $junkLen += $segLen + 2;
+                                # (note: this will not copy the trailer after PreviewImage,
+                                #  which is a 14kB block full of zeros for the A77)
+                            }
+                        }
+                        $junkLen -= 32;
+                    }
                     $newPos += $junkLen;
                 }
                 # fix up the preview offsets to point to the start of the new image
-                my $previewInfo = $self->{PREVIEW_INFO};
-                delete $self->{PREVIEW_INFO};
+                my $previewInfo = $$self{PREVIEW_INFO};
+                delete $$self{PREVIEW_INFO};
                 my $fixup = $$previewInfo{Fixup};
                 $newPos += ($$previewInfo{BaseShift} || 0);
@@ -4511,5 +5861,5 @@
                 if ($$previewInfo{Relative}) {
                     # adjust for our base by looking at how far the pointer got shifted
-                    $newPos -= $fixup->GetMarkerPointers($outfile, 'PreviewImage');
+                    $newPos -= ($fixup->GetMarkerPointers($outfile, 'PreviewImage') || 0);
                 } elsif ($$previewInfo{ChangeBase}) {
                     # Leica S2 uses relative offsets for the preview only (leica sucks)
@@ -4548,5 +5898,5 @@
                     if ($$delGroup{Trailer}) {
                         $verbose and print $out "  Deleting unknown trailer ($extra bytes)\n";
-                        ++$self->{CHANGED};
+                        ++$$self{CHANGED};
                     } else {
                         # copy over unknown trailer
@@ -4564,4 +5914,10 @@
             last;   # all done parsing file
 
+        } elsif ($marker==0xd9 and $isEXV) {
+            # write EXV EOI (any trailer will be lost)
+            Write($outfile, "\xff\xd9") or $err = 1;
+            $rtnVal = 1;
+            last;
+
         } elsif ($marker==0x00 or $marker==0x01 or ($marker>=0xd0 and $marker<=0xd7)) {
             $verbose and $marker and print $out "JPEG $markerName:\n";
@@ -4573,5 +5929,5 @@
         # NOTE: A 'next' statement after this point will cause $$segDataPt
         #       not to be written if there is an output file, so in this case
-        #       the $self->{CHANGED} flags must be updated
+        #       the $$self{CHANGED} flags must be updated
         #
         my $segDataPt = \$segData;
@@ -4583,9 +5939,15 @@
             }
         }
+        # group delete of APP segments
+        if ($$delGroup{$dirName}) {
+            $verbose and print $out "  Deleting $dirName segment\n";
+            $self->Warn('ICC_Profile deleted. Image colors may be affected') if $dirName eq 'ICC_Profile';
+            ++$$self{CHANGED};
+            next Marker;
+        }
         my ($segType, $del);
         # rewrite this segment only if we are changing a tag which is contained in its
         # directory (or deleting '*', in which case we need to identify the segment type)
         while (exists $$editDirs{$markerName} or $$delGroup{'*'}) {
-            my $oldChanged = $self->{CHANGED};
             if ($marker == 0xe0) {              # APP0 (JFIF, CIFF)
                 if ($$segDataPt =~ /^JFIF\0/) {
@@ -4631,9 +5993,33 @@
             } elsif ($marker == 0xe1) {         # APP1 (EXIF, XMP)
                 # check for EXIF data
-                if ($$segDataPt =~ /^$exifAPP1hdr/) {
+                if ($$segDataPt =~ /^(.{0,4})$exifAPP1hdr/is) {
+                    my $hdrLen = length $exifAPP1hdr;
+                    if (length $1) {
+                        $hdrLen += length $1;
+                        $self->Error('Unknown garbage at start of EXIF segment',1);
+                    } elsif ($$segDataPt !~ /^Exif\0/) {
+                        $self->Error('Incorrect EXIF segment identifier',1);
+                    }
                     $segType = 'EXIF';
-                    $doneDir{IFD0} and $self->Warn('Multiple APP1 EXIF segments');
+                    last unless $$editDirs{IFD0};
+                    # add this data to the combined data if it exists
+                    if (defined $combinedSegData) {
+                        $combinedSegData .= substr($$segDataPt,$hdrLen);
+                        $segDataPt = \$combinedSegData;
+                        $segPos = $firstSegPos;
+                        $length = length $combinedSegData;  # update length
+                    }
+                    # peek ahead to see if the next segment is extended EXIF
+                    if ($dirOrder[0] eq 'ExtendedEXIF') {
+                        # initialize combined data if necessary
+                        unless (defined $combinedSegData) {
+                            $combinedSegData = $$segDataPt;
+                            $firstSegPos = $segPos;
+                            $self->Warn('File contains multi-segment EXIF',1);
+                        }
+                        next Marker;    # get the next segment to combine
+                    }
+                    $doneDir{IFD0} and $self->Warn('Multiple APP1 EXIF records');
                     $doneDir{IFD0} = 1;
-                    last unless $$editDirs{IFD0};
                     # check del groups now so we can change byte order in one step
                     if ($$delGroup{IFD0} or $$delGroup{EXIF}) {
@@ -4645,7 +6031,7 @@
                     my %dirInfo = (
                         DataPt   => $segDataPt,
-                        DataPos  => $segPos,
-                        DirStart => 6,
-                        Base     => $segPos + 6,
+                        DataPos  => -$hdrLen, # (remember: relative to Base!)
+                        DirStart => $hdrLen,
+                        Base     => $segPos + $hdrLen,
                         Parent   => $markerName,
                         DirName  => 'IFD0',
@@ -4655,9 +6041,17 @@
                     my $buff = $self->WriteDirectory(\%dirInfo, $tagTablePtr, \&WriteTIFF);
                     if (defined $buff) {
-                        # update segment with new data
-                        $$segDataPt = $exifAPP1hdr . $buff;
+                        undef $$segDataPt;  # free the old buffer
+                        $segDataPt = \$buff;
                     } else {
                         last Marker unless $self->Options('IgnoreMinorErrors');
-                        $self->{CHANGED} = $oldChanged; # nothing changed
+                    }
+                    # delete segment if IFD contains no entries
+                    length $$segDataPt or $del = 1, last;
+                    if (length($$segDataPt) + length($exifAPP1hdr) > $maxSegmentLen) {
+                        if ($self->Options('NoMultiExif')) {
+                            $self->Error('EXIF is too large for JPEG segment');
+                        } else {
+                            $self->Warn('Writing multi-segment EXIF',1);
+                        }
                     }
                     # switch to buffered output if required
@@ -4670,6 +6064,15 @@
                         $$self{LeicaTrailer}{Fixup}{Start} += 18 if $$self{LeicaTrailer};
                     }
-                    # delete segment if IFD contains no entries
-                    $del = 1 unless length($$segDataPt) > length($exifAPP1hdr);
+                    # write as multi-segment
+                    my $n = WriteMultiSegment($outfile, $marker, $exifAPP1hdr, $segDataPt, 'EXIF');
+                    if (not $n) {
+                        $err = 1;
+                    } elsif ($n > 1 and $oldOutfile) {
+                        # (punt on this because updating the pointers would be a real pain)
+                        $self->Error("Can't write multi-segment EXIF with external pointers");
+                    }
+                    undef $combinedSegData;
+                    undef $$segDataPt;
+                    next Marker;
                 # check for XMP data
                 } elsif ($$segDataPt =~ /^($xmpAPP1hdr|$xmpExtAPP1hdr)/) {
@@ -4688,13 +6091,17 @@
                                 my ($size, $off) = unpack('x67N2', $$segDataPt);
                                 $guid = substr($$segDataPt, 35, 32);
-                                # remember extended data for each GUID
-                                $extXMP = $extendedXMP{$guid};
-                                if ($extXMP) {
-                                    $size == $$extXMP{Size} or $extendedXMP{Error} = 'Invalid size';
+                                if ($guid =~ /[^A-Za-z0-9]/) { # (technically, should be uppercase)
+                                    $extendedXMP{Error} = 'Invalid GUID';
                                 } else {
-                                    $extXMP = $extendedXMP{$guid} = { };
+                                    # remember extended data for each GUID
+                                    $extXMP = $extendedXMP{$guid};
+                                    if ($extXMP) {
+                                        $size == $$extXMP{Size} or $extendedXMP{Error} = 'Inconsistent size';
+                                    } else {
+                                        $extXMP = $extendedXMP{$guid} = { };
+                                    }
+                                    $$extXMP{Size} = $size;
+                                    $$extXMP{$off} = substr($$segDataPt, 75);
                                 }
-                                $$extXMP{Size} = $size;
-                                $$extXMP{$off} = substr($$segDataPt, 75);
                             }
                         } else {
@@ -4707,7 +6114,30 @@
                         # reconstruct an XMP super-segment
                         $$segDataPt = $xmpAPP1hdr;
-                        $$segDataPt .= $_ foreach @{$extendedXMP{Main}};
+                        my $goodGuid = '';
+                        foreach (@{$extendedXMP{Main}}) {
+                            # get the HasExtendedXMP GUID if it exists
+                            if (/:HasExtendedXMP\s*(=\s*['"]|>)(\w{32})/) {
+                                # warn of subsequent XMP blocks specifying a different
+                                # HasExtendedXMP (have never seen this)
+                                if ($goodGuid and $goodGuid ne $2) {
+                                    $self->WarnOnce('Multiple XMP segments specifying different extended XMP GUID');
+                                }
+                                $goodGuid = $2; # GUID for the standard extended XMP
+                            }
+                            $$segDataPt .= $_;
+                        }
+                        # GUID of the extended XMP that we want to read
+                        my $readGuid = $$self{OPTIONS}{ExtendedXMP} || 0;
+                        $readGuid = $goodGuid if $readGuid eq '1';
                         foreach $guid (sort keys %extendedXMP) {
-                            next unless length $guid == 32;     # ignore other keys
+                            next unless length $guid == 32;     # ignore other (internal) keys
+                            if ($guid ne $readGuid and $readGuid ne '2') {
+                                my $non = $guid eq $goodGuid ? '' : 'non-';
+                                $self->Warn("Ignored ${non}standard extended XMP (GUID $guid)");
+                                next;
+                            }
+                            if ($guid ne $goodGuid) {
+                                $self->Warn("Reading non-standard extended XMP (GUID $guid)");
+                            }
                             $extXMP = $extendedXMP{$guid};
                             next unless ref $extXMP eq 'HASH';  # (just to be safe)
@@ -4723,5 +6153,5 @@
                                 $$segDataPt .= $$extXMP{$_} foreach @offsets;
                             } else {
-                                $extendedXMP{Error} = 'Missing XMP data';
+                                $self->Error("Incomplete extended XMP (GUID $guid)", 1);
                             }
                         }
@@ -4750,5 +6180,4 @@
                         }
                     } else {
-                        $self->{CHANGED} = $oldChanged;
                         $verbose and print $out "    [XMP rewritten with no changes]\n";
                         if ($doneDir{XMP} > 1) {
@@ -4781,46 +6210,72 @@
                     $self->Warn('Ignored APP1 XMP segment with non-standard header', 1);
                 }
-            } elsif ($marker == 0xe2) {         # APP2 (ICC Profile, FPXR)
-                if ($$segDataPt =~ /^ICC_PROFILE\0/) {
+            } elsif ($marker == 0xe2) {         # APP2 (ICC Profile, FPXR, MPF)
+                if ($$segDataPt =~ /^ICC_PROFILE\0/ and $length >= 14) {
                     $segType = 'ICC_Profile';
                     $$delGroup{ICC_Profile} and $del = 1, last;
                     # must concatenate blocks of profile
-                    my $block_num = ord(substr($$segDataPt, 12, 1));
-                    my $blocks_tot = ord(substr($$segDataPt, 13, 1));
-                    $combinedSegData = '' if $block_num == 1;
-                    unless (defined $combinedSegData) {
-                        $self->Warn('APP2 ICC_Profile segments out of sequence');
+                    my $chunkNum = Get8u($segDataPt, 12);
+                    my $chunksTot = Get8u($segDataPt, 13);
+                    if (defined $iccChunksTotal) {
+                        # abort parsing ICC_Profile if the total chunk count is inconsistent
+                        if ($chunksTot != $iccChunksTotal and defined $iccChunkCount) {
+                            # an error because the accumulated profile data will be lost
+                            $self->Error('Inconsistent ICC_Profile chunk count', 1);
+                            undef $iccChunkCount; # abort ICC_Profile parsing
+                            undef $chunkNum;      # avoid 2nd warning below
+                            ++$$self{CHANGED};    # we are deleting the bad chunks before this one
+                        }
+                    } else {
+                        $iccChunkCount = 0;
+                        $iccChunksTotal = $chunksTot;
+                        $self->Warn('ICC_Profile chunk count is zero') if !$chunksTot;
+                    }
+                    if (defined $iccChunkCount) {
+                        # save this chunk
+                        if (defined $iccChunk[$chunkNum]) {
+                            $self->Warn("Duplicate ICC_Profile chunk number $chunkNum");
+                            $iccChunk[$chunkNum] .= substr($$segDataPt, 14);
+                        } else {
+                            $iccChunk[$chunkNum] = substr($$segDataPt, 14);
+                        }
+                        # continue accumulating chunks unless we have all of them
+                        next Marker unless ++$iccChunkCount >= $iccChunksTotal;
+                        undef $iccChunkCount;   # prevent reprocessing
+                        $doneDir{ICC_Profile} = 1;
+                        # combine the ICC_Profile chunks
+                        my $icc_profile = '';
+                        defined $_ and $icc_profile .= $_ foreach @iccChunk;
+                        undef @iccChunk;   # free memory
+                        $segDataPt = \$icc_profile;
+                        $length = length $icc_profile;
+                        my $tagTablePtr = GetTagTable('Image::ExifTool::ICC_Profile::Main');
+                        my %dirInfo = (
+                            DataPt   => $segDataPt,
+                            DataPos  => $segPos + 14,
+                            DataLen  => $length,
+                            DirStart => 0,
+                            DirLen   => $length,
+                            Parent   => $markerName,
+                        );
+                        my $newData = $self->WriteDirectory(\%dirInfo, $tagTablePtr);
+                        if (defined $newData) {
+                            undef $$segDataPt;  # free the old buffer
+                            $segDataPt = \$newData;
+                        }
+                        length $$segDataPt or $del = 1, last;
+                        # write as ICC multi-segment
+                        WriteMultiSegment($outfile, $marker, "ICC_PROFILE\0", $segDataPt, 'ICC') or $err = 1;
+                        undef $$segDataPt;
                         next Marker;
-                    }
-                    $combinedSegData .= substr($$segDataPt, 14);
-                    # continue accumulating segments unless this is the last
-                    next Marker unless $block_num == $blocks_tot;
-                    $doneDir{ICC_Profile} and $self->Warn('Multiple ICC_Profile records');
-                    $doneDir{ICC_Profile} = 1;
-                    $segDataPt = \$combinedSegData;
-                    $length = length $combinedSegData;
-                    my $tagTablePtr = GetTagTable('Image::ExifTool::ICC_Profile::Main');
-                    my %dirInfo = (
-                        DataPt   => $segDataPt,
-                        DataPos  => $segPos + 14,
-                        DataLen  => $length,
-                        DirStart => 0,
-                        DirLen   => $length,
-                        Parent   => $markerName,
-                    );
-                    my $newData = $self->WriteDirectory(\%dirInfo, $tagTablePtr);
-                    if (defined $newData) {
-                        undef $$segDataPt;  # free the old buffer
-                        $segDataPt = \$newData;
-                    }
-                    length $$segDataPt or $del = 1, last;
-                    # write as ICC multi-segment
-                    WriteMultiSegment($outfile, $marker, "ICC_PROFILE\0", $segDataPt, 'ICC') or $err = 1;
-                    undef $combinedSegData;
-                    undef $$segDataPt;
-                    next Marker;
+                    } elsif (defined $chunkNum) {
+                        $self->WarnOnce('Invalid or extraneous ICC_Profile chunk(s)');
+                        # fall through to preserve this extra profile...
+                    }
                 } elsif ($$segDataPt =~ /^FPXR\0/) {
                     $segType = 'FPXR';
                     $$delGroup{FlashPix} and $del = 1;
+                } elsif ($$segDataPt =~ /^MPF\0/) {
+                    $segType = 'MPF';
+                    $$delGroup{MPF} and $del = 1;
                 }
             } elsif ($marker == 0xe3) {         # APP3 (Kodak Meta)
@@ -4834,5 +6289,5 @@
                     my %dirInfo = (
                         DataPt   => $segDataPt,
-                        DataPos  => $segPos,
+                        DataPos  => -6, # (remember: relative to Base!)
                         DirStart => 6,
                         Base     => $segPos + 6,
@@ -4848,5 +6303,4 @@
                     } else {
                         last Marker unless $self->Options('IgnoreMinorErrors');
-                        $self->{CHANGED} = $oldChanged; # nothing changed
                     }
                     # delete segment if IFD contains no entries
@@ -4880,6 +6334,4 @@
                         $newData = 'Ducky' . $newData if length $newData;
                         $segDataPt = \$newData;
-                    } else {
-                        $self->{CHANGED} = $oldChanged;
                     }
                     $del = 1 unless length $$segDataPt;
@@ -4921,6 +6373,4 @@
                         undef $$segDataPt;  # free the old buffer
                         $segDataPt = \$newData;
-                    } else {
-                        $self->{CHANGED} = $oldChanged;
                     }
                     length $$segDataPt or $del = 1, last;
@@ -4930,4 +6380,13 @@
                     undef $$segDataPt;
                     next Marker;
+                }
+            } elsif ($marker == 0xee) {         # APP14 (Adobe)
+                if ($$segDataPt =~ /^Adobe/) {
+                    $segType = 'Adobe';
+                    # delete it and replace it later if editing
+                    if ($$delGroup{Adobe} or $$editDirs{Adobe}) {
+                        $del = 1;
+                        undef $doneDir{Adobe};  # so we can add it back again above
+                    }
                 }
             } elsif ($marker == 0xfe) {         # COM (JPEG comment)
